;BeginWork:
;End__Work:
format PE GUI 4.0;
include 'd:\fasm\include\win32a.inc'
entry start;
WMU_MOUSE   equ WM_USER + 6  
 struct  MOUSEHOOKSTRUCT
          pt                    POINT
          hwnd                  dd   ?;
          wHitTestCode          dd   ?;
          dwExtraInfo           dd   ?;
        ends 
;_________CODE___________________________________________________________________
 section '_code' code readable executable 
 start:
             invoke GetModuleHandle,0;
         
             invoke DialogBoxParam,eax,ID_DIALOG,0,DialogProc,0;
             invoke ExitProcess,0;
 ;________DialogProc_____________________________________________________________
     proc DialogProc uses ebx esi edi,hdlg,msg,wparam,lparam;
                 xor eax,eax;
                 cmp [msg],WM_CLOSE;
                 je .close;                 
                 cmp [msg],WM_INITDIALOG;
                 je .initdialog;
                 cmp [msg],WMU_MOUSE;
                 je .mouse;                 
                 ret;
     ;initial Dialog                                    
         .initdialog:
                
                 invoke InstallHook_mouse,[hdlg],0;                               
         ret;
    
     ;mouse                                             
         .mouse:
                 
                
                 mov ebx,[lparam];
                 virtual at ebx;
                     .ebx MOUSEHOOKSTRUCT;
                 end virtual

                 
                 mov eax,[.ebx.pt.x];
                 mov edx,[.ebx.pt.y];
                 mov ecx,[.ebx.hwnd];
                
                 invoke wsprintf,buff_264byte,mask_mouse,eax,edx,ecx,[wparam];
                 add esp,24;
                 invoke SendDlgItemMessage,[hdlg],IDS_OUTMOUSE,WM_SETTEXT,0,0;
                 invoke SendDlgItemMessage,[hdlg],IDS_OUTMOUSE,WM_SETTEXT,0,buff_264byte;
         ret;
  
     ;close                                             
         .close:
                 invoke UninstallHook_mouse;;                 
                 invoke EndDialog,[hdlg],0;
                 xor eax,eax;
         ret;

     ret;
     endp;                           
;_________DATA___________________________________________________________________
 section '_data' data readable writeable;

 buff_264byte         rb  264; 
  mask_mouse           db   'Coordinate X: %u, Y: %u, handle: %u, Notiications: %u',0;  

;_________RESOURCE________________________________________________________________
 section '_res' resource data readable writeable;
          ID_DIALOG              =  1000;
       
         IDS_OUTMOUSE           =  1202;

       

 directory RT_DIALOG,my_dialogs

 resource         my_dialogs,ID_DIALOG,LANG_ENGLISH,my_dialog;

  dialog             my_dialog,'DialogHookMouse',100,100,220,100,WS_VISIBLE+WS_OVERLAPPEDWINDOW
                     dialogitem  'STATIC','Testing string for mouse',IDS_OUTMOUSE,10,10,210,13,WS_VISIBLE;        
    enddialog   

;_______IMPORT___________________________________________________________________
 section '_import' import data readable writeable;
 library        kernel32,'kernel32.dll',user32,'user32.dll',comctl32,'comctl32.dll',\
                    comdlg32,'COMDLG32.DLL',getlasterror,'MyGetLastError.dll',\;
                    gdi32,'gdi32.dll',advapi32,'advapi32.dll',hook_mouse,'hook_mouse.dll' 

  include 'd:\fasm\include\api\kernel32.inc';
 include 'd:\fasm\include\api\user32.inc';
 include 'd:\fasm\include\api\comctl32.inc'
 include 'd:\fasm\include\api\comdlg32.inc'
 include 'd:\fasm\include\api\gdi32.inc';
 include 'd:\fasm\include\api\advapi32.inc';


 import hook_mouse,InstallHook_mouse,'InstallHook_Mouse',\
                   UninstallHook_mouse,'UninstallHook_Mouse'; 