;Begin: 27.12.2017
;END:

format PE DLL
include 'd:\fasm\include\win32a.inc';
entry dllMain;
WMU_MOUSE	equ  WM_USER + 6;
;_____________________________________________________________________________________
section '_code' code readable executable;
proc dllMain dllInst,fdwReason,lprReserved
	     cmp [fdwReason],DLL_PROCESS_ATTACH
	     je attach_process;
	     cmp [fdwReason],DLL_PROCESS_DETACH;
	     je detach_process;
	     cmp [fdwReason],DLL_THREAD_ATTACH;
	     je attach_thread;
	     cmp [fdwReason],DLL_THREAD_DETACH;
	     je detach_thread;
attach_process:
	      push[dllInst];
	      pop[hDll];
	      mov eax,TRUE;
	      ret;
detach_process:

ret;
attach_thread:
	      mov eax,TRUE;
	      ret;
detach_thread:
ret;
endp;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
proc MouseProc,nCode,wparam,lparam;
	invoke CallNextHookEx,[hHook_mouse],[nCode],[wparam],[lparam];
	mov edx, [lparam];
	mov eax,[edx+MOUSEHOOKSTRUCT.pt.y];
	mov [mousehook.pt.y],eax;
	mov eax,[edx+MOUSEHOOKSTRUCT.pt.x];
	mov [mousehook.pt.x],eax;
	mov eax,[edx+MOUSEHOOKSTRUCT.hwnd];
	mov dword[mousehook.hwnd],eax;
	mov eax,[edx+MOUSEHOOKSTRUCT.wHitTestCode];
	mov dword[mousehook.wHitTestCode],eax;
	mov eax,[edx+MOUSEHOOKSTRUCT.dwExtraInfo];
	mov dword[mousehook.dwExtraInfo],eax;
	invoke PostMessage,[hWnd],WMU_MOUSE,[wparam],mousehook;
	xor eax,eax;
ret;
endp;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
proc InstallHook_Mouse, hwnd,Id;
	     push[hwnd];
	     pop [hWnd]
;set hook and get descriptor window for send message PostMessage
	     invoke SetWindowsHookEx,WH_MOUSE,MouseProc,[hDll],[Id];
	     mov [hHook_mouse],eax;


ret;
endp;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
proc UninstallHook_Mouse
	     invoke  UnhookWindowsHookEx,[hHook_mouse]
ret;
endp;

;shared section data use in hooks 
;______________________________________________________________________________________
 section '.sdata' readable writeable shareable

 ;structure
 struct MOUSEHOOKSTRUCT
       pt	       POINT
       hwnd	       dd   ?;
       wHitTestCode    dd   ?;
       dwExtraInfo     dd   ?;
 ends
 mousehook MOUSEHOOKSTRUCT;
 test_value             dd  123456h;


 ;descriptors
 hWnd			dd  ?;
 hHook_mouse		dd  ?;
 hDll			dd  ?;

;_____________________________________________________________________________________
 section '_export' export data readable
	 export 'hook_mouse.dll',\
		 MouseProc,'MouseProc',\
		 InstallHook_Mouse,'InstallHook_Mouse',\
		 UninstallHook_Mouse,'UninstallHook_Mouse'


;_____________________________________________________________________________________
 section '_import' import data readable;
	library user32,'user32.dll',kernel32,'kernel32.dll'
 include 'd:\fasm\include\api\user32.inc';
 include 'd:\fasm\include\api\kernel32.inc';
;_____________________________________________________________________________________
 section '_fix' fixups readable discardable
	dd 0,8;